/* ************************************************************************
 *   File: Guild.h                                                         *
 *  Usage: GuildMaster's: Definition for everything needed by shop.c       *
 *                                                                         *
 * Written by Jason Goodwin.   jgoodwin@expert.cc.purdue.edu               *
 ************************************************************************ */

struct guild_data
{
	int vnum;                             /* number of the guild */
	int skills_and_spells[MAX_SKILLS+1];  /*array to keep track of which things we'll train */
	float charge;                         /* charge * skill level = how much we'll charge */
	char *no_such_skill;                  /* message when we don't teach that skill */
	char *not_enough_gold;                /* message when the student doesn't have enough gold */
	int minlvl;                           /* Minumum level guildmaster will train */
	int gm;                               /* GM's vnum */
	int with_who;                         /* whom we dislike */
	int open, close;                      /*when we will train */
	SPECIAL(*func);                       /* secondary spec_proc for the GM */
};

#define GM_NUM(i)  (guild_index[i].vnum)
#define GM_CHARGE(i) (guild_index[i].charge)
#define GM_MINLVL(i) (guild_index[i].minlvl)
#define GM_TRAINER(i) (guild_index[i].gm)
#define GM_WITH_WHO(i) (guild_index[i].with_who)
#define GM_OPEN(i) (guild_index[i].open)
#define GM_CLOSE(i) (guild_index[i].close)
#define GM_FUNC(i) (guild_index[i].func)
#define GM_NO_SKILL(i)	 (guild_index[i].no_such_skill)
#define GM_NO_GOLD(i)	 (guild_index[i].not_enough_gold)
#define GM_COST(i,j,k) (int) (GM_CHARGE(i)*spell_info[j].min_level[(int)GET_CLASS(k)])

#define NOTRAIN_GOOD(i)		(IS_SET((GM_WITH_WHO(i)),TRADE_NOGOOD))
#define NOTRAIN_EVIL(i)		(IS_SET((GM_WITH_WHO(i)),TRADE_NOEVIL))
#define NOTRAIN_NEUTRAL(i)	(IS_SET((GM_WITH_WHO(i)),TRADE_NONEUTRAL))

#define NOTRAIN_SHAMAN(i)		(IS_SET((GM_WITH_WHO(i)),TRADE_NOSHAMAN))
#define NOTRAIN_HEALER(i)	(IS_SET((GM_WITH_WHO(i)),TRADE_NOHEALER))
#define NOTRAIN_THIEF(i)	    (IS_SET((GM_WITH_WHO(i)),TRADE_NOTHIEF))
#define NOTRAIN_MUSA(i) 		(IS_SET((GM_WITH_WHO(i)),TRADE_NOMUSA))

#define NOTRAIN_JA(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOJA))
#define NOTRAIN_CHUCK(i)	(IS_SET((GM_WITH_WHO(i)), TRADE_NOCHUCK))
#define NOTRAIN_IN(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOIN))
#define NOTRAIN_MYO(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOMYO))
#define NOTRAIN_JIN(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOJIN))
#define NOTRAIN_SA(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOSA))  
#define NOTRAIN_OH(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOOH))  
#define NOTRAIN_MI(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOMI))  
#define NOTRAIN_SIN(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOSIN))
#define NOTRAIN_YU(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOYU))    
#define NOTRAIN_SUL(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOSUL))    
#define NOTRAIN_FISH(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOFISH))
#define NOTRAIN_HAE(i)		(IS_SET((GM_WITH_WHO(i)), TRADE_NOHAE))

extern int prac_params[4][NUM_CLASSES];

#define LEARNED(ch) (prac_params[LEARNED_LEVEL][(int)GET_CLASS(ch)])
#define MINGAIN(ch) (prac_params[MIN_PER_PRAC][(int)GET_CLASS(ch)])
#define MAXGAIN(ch) (prac_params[MAX_PER_PRAC][(int)GET_CLASS(ch)])
#define SPLSKL(ch)  (prac_types[prac_params[PRAC_TYPE][(int)GET_CLASS(ch)]])

