/*************************************************************************
 *   File: job.kwoen.c		                             Land of Dangun    *
 *  Usage: Job FIST's Fighting skills				                       *
 *                                                                         *
 *  All rights reserved.  See license.doc for complete information.        *
 *                                                                         *
 *  Land of Dangun is based on CircleMUD, Copyright (C) 1990, 1991.        *
 ************************************************************************ */

#include "conf.h"
#include "sysdep.h"


#include "structs.h"
#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"

/* extern functions */
ACMD(do_hand);
ACMD(do_footwork);
ACMD(do_keownmind);
ACMD(do_fist);
ACMD(do_kick);
ACMD(do_chung);
ACMD(do_frontkick);
ACMD(do_chunjang);
ACMD(do_sstar);
ACMD(do_turnkick);
ACMD(do_bung);
ACMD(do_tkick);
ACMD(do_byuckjang);
ACMD(do_sokick);
ACMD(do_windkick);
ACMD(do_defend);
ACMD(do_mchung);
ACMD(do_jungju);
ACMD(do_pakick);
ACMD(do_kneedef);
ACMD(do_neckhood);
ACMD(do_paeye);
ACMD(do_upkick);
ACMD(do_kikongpa);
ACMD(do_footgrab);
ACMD(do_updraw);


ACMD(do_keownmind)
{
	struct affected_type af;

	if (IS_NPC(ch) || !GET_SKILL(ch, SKILL_MIND))
	{
		send_to_char(ch, "     ϴ.\r\n");
		return;
	}

	if (FIGHTING(ch))
	{
		send_to_char(ch, "ο߿    ϴ.\r\n");
		return;
	}

	if (AFF_FLAGGED(ch, AFF_HEALUP)) 
	{
		send_to_char(ch, "̹ ɹ Դϴ.\r\n");
		return;
	}
	else
	{
		af.location = APPLY_HEALUP;
		af.duration = 2;
		af.modifier = 10; // + (GET_SKILL(ch, SKILL_HAND) * 1.5);
//		af.bitvector = AFF_HEALUP;
		affect_to_char(ch, &af);
		
		act("    ٵ  濡 ϴ.", FALSE, ch, 0, 0, TO_CHAR);
		act("$nԲ    ٵ  濡 ϴ.", FALSE, ch, 0, 0, TO_ROOM);
	}
}

ACMD(do_updraw)
{
    struct char_data *vict;
    int percent, prob, flag = 0;

    if (!GET_SKILL(ch, SKILL_UPDRAW))
    {
		send_to_char(ch, " ׷  ʾҽϴ.\r\n");
		return;
    }

	if (!FIGHTING(ch))
	{
		send_to_char(ch, "ο ƴմϴ.\r\n");
		return;
	}
	else
	{
		vict = FIGHTING(ch);
	}

    percent = rand_number(1, 101);	/* 101% is a complete failure */
    prob = GET_SKILL(ch, SKILL_UPDRAW);

	if (GET_MANA(ch) < 30 || GET_MOVE(ch) < 30)
	{
		send_to_char(ch, "ġ⸦ ϱ⿡  ʹ ֽϴ.\r\n");
		flag = 1;
	}
	else
	{
		if (percent > 20)
		{
			act(" $N      մϴ.", FALSE, ch, 0, vict, TO_CHAR);
			damage(ch, vict, 0, SKILL_UPDRAW);
			WAIT_STATE(ch, PULSE_VIOLENCE * 1.5);
		}
		else
		{
			act(" $N     ϴ.", FALSE, ch, 0, vict, TO_CHAR);
			act("$nԲ      ϴ.", FALSE, ch, 0, vict, TO_VICT);
			act("$nԲ $N     ϴ.", FALSE, ch, 0, vict, TO_NOTVICT);	
			GET_POS(vict) = POS_SITTING;

			if (prob == 50)
				damage(ch, vict, prob * 60, SKILL_UPDRAW);
			else
				damage(ch, vict, prob * 40, SKILL_UPDRAW);

			WAIT_STATE(vict, PULSE_VIOLENCE * 2);
		}

		GET_MANA(ch) -= 30;
		GET_MOVE(ch) -= 30;
	}

	if (flag = 0)
		WAIT_STATE(ch, PULSE_VIOLENCE * 2.5);
}

ACMD(do_hand)
{
	struct affected_type af;

	if (FIGHTING(ch))
	{
		send_to_char(ch, "ο Ű   ǰ   ͱ.\r\n");
		return;	
	}

	if (!GET_SKILL(ch, SKILL_HAND))
	{
		send_to_char(ch, "   ʾҽϴ.\r\n");
		return;
	}

	if (AFF_FLAGGED(ch, AFF_DAMROLL)) {
		send_to_char(ch, "̹  Դϴ.\r\n");
		return;
	}
	else
	{
		af.location = APPLY_DAMROLL;
		af.duration = 2;
		af.modifier = GET_SKILL(ch, SKILL_HAND) * 1.5;
		af.bitvector = AFF_DAMROLL;
		affect_to_char(ch, &af);
		
		send_to_char(ch, "  Ȳ ó ʿŸ  Դϴ.\r\n");
	}
}

