/*************************************************************************
 *   File: job.musa.c		                             Land of Dangun	   *
 *  Usage: Job Musa's Fighting skills				                       *
 *                                                                         *
 *  All rights reserved.  See license.doc for complete information.        *
 *                                                                         *
 *  Land of Dangun is based on CircleMUD, Copyright (C) 1990, 1991.        *
 ************************************************************************ */

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"

/* extern functions */
ACMD(do_cross);
ACMD(do_jukgum);
ACMD(do_hwanpung);
ACMD(do_doublehand);
ACMD(do_kiyung);
ACMD(do_ikook);
ACMD(do_push);
ACMD(do_suyeon);
ACMD(do_yulpung);
ACMD(do_kihap);
ACMD(do_simma);
ACMD(do_jilpung);
ACMD(do_mangryang);
ACMD(do_gyulpan);
ACMD(do_manghon);

ACMD(do_cross)
{
	struct char_data *vict;
	int num, percent, prob;
 
	percent = rand_number(1, 101);
	prob = GET_SKILL(ch, SKILL_CROSS);
	
	if(GET_SKILL(ch, SKILL_CROSS) > 20)
        GET_SKILL(ch, SKILL_CROSS) = 20;
	
	if(IS_NPC(ch))
		return;
	
	if (!FIGHTING(ch))
	{
		send_to_char(ch, "ο ƴմϴ.\r\n");
		return;
	}
	else
	{
		vict = FIGHTING(ch);
	}

	if(!GET_SKILL(ch, SKILL_CROSS)) 
	{
		send_to_char(ch, "׷  𸨴ϴ.\r\n");
		return;
	}
	
	if(ch != vict && ROOM_FLAGGED(ch->in_room, ROOM_PEACEFUL)) 
	{
		send_to_char(ch, "̰ ο  Դϴ.\r\n");
		return;
	}
	
	num = 2;

	if(GET_MOVE(ch) < (num * GET_LEVEL(ch))) 
	{
		send_to_char(ch, "̵ !!\r\n");
		return;
	}
	
	GET_MOVE(ch) -= abs(num * (GET_LEVEL(ch)));
	
	if(percent > prob) {
		send_to_char(ch, "  մϴ!!\r\n");
		return;
	}
	
	act(" $N$J  û浵 ¦ ġѵϴ.\r\n", 
		 FALSE, ch, 0, vict, TO_CHAR);
	act("$n$j $N$J  û浵 ¦ ġѵϴ.\r\n", 
		 FALSE, ch, 0, vict, TO_CHAR);
	WAIT_STATE(ch, PULSE_VIOLENCE *  0.5);

	act("$n$j $p$j ֵθ $N ޷ϴ.\r\n", FALSE, ch, 0, vict, TO_ROOM);
	act(" $p$j ֵθ $N ޷ϴ.\r\n", FALSE, ch, 0, vict, TO_CHAR);

	num--;
	hit(ch, vict, TYPE_UNDEFINED);
	
	while(num) {
		if(FIGHTING(ch))
			hit(ch, FIGHTING(ch), TYPE_UNDEFINED);
		num--;
	}
	WAIT_STATE(ch, PULSE_VIOLENCE *  1.5);
}                             	


ACMD(do_doublehand)
{	
}

ACMD(do_jukgum)
{
//	struct char_data *vict;
	
}

ACMD(do_kihap)
{
	struct affected_type af[1];
	
	if (!GET_SKILL(ch, SKILL_KIHAP))
	{
		send_to_char(ch, "   ʾҽϴ.\r\n");
		return;
	}

	af[0].location = APPLY_DAMROLL;
	af[0].duration = 46;
	af[0].modifier = 41;
	af[0].bitvector = 0;

	af[1].location = APPLY_HIT;
	af[1].duration = 46;
	af[1].modifier = 133;
	af[1].bitvector = 0;

	if (af[0].duration > 0 && af[1].duration > 0)
	{
		af[0].duration = 0;
		af[1].duration = 0;
	}
		
	affect_join(ch, af, FALSE, FALSE, FALSE, FALSE);
	affect_join(ch, af+1, FALSE, FALSE, FALSE, FALSE);

	send_to_char(ch, "  谡   ϴ. '̾߾ƾƾ~~~'\r\n");

}