/* ************************************************************************
*  File: dangun.h                                           For CircleMUD *
*                                                                         *
*                                   Copyleft Registerd by savvy 2004.11.9 *
************************************************************************ */

/* memory utils **********************************************************/
#define CREATE(result, type, number)  do {\
	if ((number) * sizeof(type) <= 0)	\
		perror("SYSERR: Zero bytes or less requested");	\
	if (!((result) = (type *) calloc ((number), sizeof(type))))	\
		{ perror("SYSERR: malloc failure"); abort(); } } while(0)

#define RECREATE(result,type,number) do {\
  if (!((result) = (type *) realloc ((result), sizeof(type) * (number))))\
		{ perror("SYSERR: realloc failure"); abort(); } } while(0)

/* basic bitvector utils *************************************************/
#define Q_FIELD(x)  ((int) (x) / 32)
#define Q_BIT(x)    (1 << ((x) % 32))
 
#define IS_SET_AR(var, bit)       ((var)[Q_FIELD(bit)] & Q_BIT(bit))
#define SET_BIT_AR(var, bit)      ((var)[Q_FIELD(bit)] |= Q_BIT(bit))
#define REMOVE_BIT_AR(var, bit)   ((var)[Q_FIELD(bit)] &= ~Q_BIT(bit))
#define TOGGLE_BIT_AR(var, bit)   ((var)[Q_FIELD(bit)] = \
                                   (var)[Q_FIELD(bit)] ^ Q_BIT(bit))
#define IS_SET(flag,bit)  ((flag) & (bit))
#define SET_BIT(var,bit)  ((var) |= (bit))
#define REMOVE_BIT(var,bit)  ((var) &= ~(bit))
#define TOGGLE_BIT(var,bit) ((var) ^= (bit))

/* world file 
()(lib\segye\*.se)

+ȣ
̸%
 伳
%
1()
A B C
D E F G H
%
 ȣ       : s(),n(),w(),e(),u(),d()
%
 ȣ       : ..
.
.
%
E : END( ĭ )
-6		Ǫ(X)
-5		Ǫ(X)
-4	ȭ	
-3	ϴ	
-2		Ǫ(X)
-1		 
0		Ϲ (X)
1		(X)
2	ǳ	ǳ(O)
3		
4		(O)
5	縷	縷(X)
6		̵Ǹ ⱸȺ(O)
7		
8		

Ÿ ǳ, ,  ϸ, 
׿¾ 縦  ߰, 
 Ⱑ 1̰ Ӱ 㿡 ⱸ  ʴ´

B : ̵
C : ǥ
*/

#define 	DR_INDOORS	(1 << 0)		// Ϲݹ	⺻
#define 	DR_NOMOB	(1 << 1)		// 	 ( )
#define 	DR_PREACT	(1 << 2)		// гƼ	ݽ HP-50%
#define 	DR_PKILL	(1 << 3)		// PK	
//#define	DR_UNKNOWN	(1 << 4)		//  
#define 	DR_QUIT		(1 << 5)		// ñ	ϰ 
//#define 	DR_UNKNOWN	(1 << 6)		//  
#define		DR_NOEXIT	(1 << 7)		// ⱸ	ⱸ Ⱥ(̵)
#define 	DR_HOLY		(1 << 8)		// 	(ȸ+a), 
#define 	DR_PRIVATE	(1 << 9)		// κи	(̵ε)
#define 	DR_NOPEEK	(1 << 10)		// 	 ȵ
#define 	DR_NVEHICLE	(1 << 11)		// Ÿ	  Ÿ 
#define 	DR_NOSAVE	(1 << 12)		// 	?
#define 	DR_NOEAST	(1 << 13)		// ʾȺ	ⱸǥ X
#define 	DR_NOWEST	(1 << 14)		// ʾȺ	ⱸǥ X
#define 	DR_NOSOUTH	(1 << 15)		// ʾȺ	ⱸǥ X
#define 	DR_NONORTH	(1 << 16)		// ʾȺ	ⱸǥ X
#define 	DR_NOUP		(1 << 17)		// ʾȺ	ⱸǥ X
#define 	DR_NODOWN	(1 << 18)		// ʾȺ	ⱸǥ X

#define		DR_DOOR_OPEN		(1 << 0)	// 
#define		DR_DOOR_CLOSE		(1 << 1)	// 
#define		DR_DOOR_PICKPROOF	(1 << 2)	// 
#define		DR_DOOR_LOCK		(1 << 3)	// 乮
#define		DR_DOOR_SAFELOCK	(1 << 4)	// 
#define		DR_DOOR_ENTER		(1 << 5)	//  : ɾ ""
#define		DR_DOOR_LEAVE		(1 << 6)	//  : ɾ ""
//#define		DR_DOOR_FAMILY		(1 << 7)	// 
//#define		DR_DOOR_FAMILY_2	(1 << 8)	// 
//#define		DR_DOOR_XXX			(1 << 9)	// ״ι
#define		DR_DOOR_AUTOCLOSE	(1 << 10)	// ڵݱ⹮
#define		DR_DOOR_LIMIT		(1 << 11)	// 
//#define		DR_DOOR_XXX2		(1 << 12)	// NONE
#define		DR_DOOR_NEED_OBJ	(1 << 13)	// Ȯι ( Ȯ  ϸ ش, 122031濡 -_-;)

#define		DR_DOOR_PRIVATE		(1 << 11)	//2048: 

/*
D : 漺
0	Ϲ	ƹ 
1	߿	HP -10
2	ô	HP -103
4	ȱ	̵ -10
8		̵ -200
16	𷡹ٶ	
32	ġ	HP, MP -10
64		MP -10
128		MP -100

(lib\dongmul\*.mob)

+ȣ
%
̸%
 ª%
 伳%
A B C D E
F G H I J
0 0 0 0 0
ڵ õ
E 

A : Ÿ	MobtypeϿ  , ƹ͵   0
*/
#define DM_C_UNDEF				   0		//
#define DM_C_HUMAN				 100		//ΰ
#define DM_C_ANIMAL				 200		//
#define DM_C_BEAST				 201		//ͼ
#define DM_C_POISON_BEAST		 202		//
#define DM_C_HORN				 203		//
#define DM_C_WING				 300		//
#define DM_C_WATER_BEAST		 400		//
#define DM_C_INSECT				 500		//
#define DM_C_POISON_INSECT		 501		//
#define DM_C_GIANT				 600		//
#define DM_C_GHOST				 700		//ͽ
#define DM_C_GHOST2				 701		//ͽ2
#define DM_C_HORN_GOBLIN		 800		//
#define DM_C_GOBLIN				 801		//ٺ
#define DM_C_SPIRIT				 900		//
#define DM_C_ADV_SPIRIT			1000		//ż
#define DM_C_IMMORTAL			1100		//

/*
B : Ŭ	MobclassϿ  , ƹ͵   0
1xx	: 01ϱ,02߱,03,04ֻ,05,09,10
11x «: 11ذ( + ڰ), 12Ǵ( + ), 14ŵ() 
2xx	ڰ: 01ϱ,02߱,03,04ֻ,05
3xx	: 01Ҹġ 
4xx	: 01ֻ,02Ȱ,05ļ
5xx	ǿ: 01ǿ, 
6xx	: 01ǳ,02,03쵵,05뵵,06,8
7xx	˻: 01ϱ,02߱,03,04ֻ,05˼
8xx	ǹ: 01ϱ,02߱,03,04ֻ,05
*/

/*  */
#define DM_CL_UNDEF					  0
#define DM_CL_LOWERMUSA				101
#define DM_CL_MIDMUSA				102
#define DM_CL_UPPERMUSA				103
#define DM_CL_TOPMUSA				104
#define DM_CL_DEFMUSA				105
#define DM_CL_GROUPMUSA				106
#define DM_CL_SOLDIER				107
#define DM_CL_VETERAN				108
#define DM_CL_GENERAL				109
#define DM_CL_BERSERK				110

/* ڰ */
#define DM_CL_LOWASSASIN			201
#define DM_CL_MIDASSASIN			202
#define DM_CL_UPPERASSASIN			203
#define DM_CL_TOPASSASIN			204
#define DM_CL_AMBUSHER				205
#define DM_CL_ASSASINMASTER			206

/*  */
#define DM_CL_PICKPOCKET			301
#define DM_CL_THIEF					302
#define DM_CL_BANDIT				303
#define DM_CL_GHOSTTHIEF			304
#define DM_CL_SNATHER				305
#define DM_CL_ROBBER				306

/*  */
#define DM_CL_CURSESHAMAN			401
#define DM_CL_VIGORSHAMAN			402
#define DM_CL_SUMMONSHAMAN			403
#define DM_CL_SPIRITSHAMAN			404
#define DM_CL_WARSHAMAN				405

/* ǿ */
#define DM_CL_WARHEALER				501
#define DM_CL_ACUPUNCTURIST			502
#define DM_CL_BLINDIST				503
#define DM_CL_DUMBIST				504
#define DM_CL_POISONER				505

/*  */
#define DM_CL_WINDDOIN				601
#define DM_CL_CLOUDDOIN				602
#define DM_CL_RAINDOIN				603
#define DM_CL_DRAGONDOIN			604
#define DM_CL_THUNDERDOIN			605
#define DM_CL_DEFDOIN				606
#define DM_CL_WARDOIN				607
/* ˻ */
#define DM_CL_LOWSWORD				701
#define DM_CL_MIDSWORD				702
#define DM_CL_UPPERSWORD			703
#define DM_CL_TOPSWORD				704
#define DM_CL_SOWRDMASTER			705

/* « */
#define DM_CL_BROKER				111
#define DM_CL_SCAMP					112
#define DM_CL_ZEALOT				113
#define DM_CL_WANGJJA				207
#define DM_CL_LION					300

/*
C : 		0  11(ڶ  ض)
D : LV(eval)	 
E : Factor	1.0 ⺻ġ, 2.0̸    ι    ϴ 
F :      	1 -  / 2 -  / 3 - (߼)
G : 	  ..
H : Position
*/

#define DM_SITTING	0	//ɾ( X, ԰ ɾִٸ  Ⱥٿ ְ)
#define DM_FIGHTING 1	//ο	(-_-ü;)
#define DM_SWIMMING 2	//	θ ̵( : )
#define DM_RESTING 4	//		 (ɴ°Ŷ   ..)
#define DM_STANDING 8	//	̵̳   ݵ ֵ ؾ

/*
 * I : attitude (ŵ-_-?)
 */
#define DM_ACT_NONE				0 			//	
#define DM_ACT_AGGRESSIVE		1			//	
#define DM_ACT_MOVE_OUT			2 			//̵	̵(ٸ Ѿ-_-)
#define DM_ACT_STAY_ZONE		4 			//̵	ڽ  ȿ ̵
#define DM_ACT_SCAVENGER		8 			//	 
#define DM_ACT_WIMPY 			16			//	(, )
#define DM_ACT_AGGR_WIMPY		32 			//̼	+(߸𸣰)
#define DM_ACT_AGGR_BACKSTAB	64			//ȶȼ	, Ͻ 
#define DM_ACT_DIGNITY			128			//		 (԰ )
#define DM_ACT_HELPER			256 		//		   ݹ 
#define DM_ACT_BOSS				512 		// θ
#define DM_ACT_CITIZEN			1024		//ѽù	?
#define DM_ACT_EXP_ZERO			2048		//ġ 0	  ġ 0
#define DM_ACT_TO_SKY			4096		//õ	  õ(ü X)
#define DM_ACT_USABLE			8192		//̱Ⱑ	̱   
#define DM_ACT_WEARABLE			16384		//ڵԱ	  ð 
#define DM_ACT_HEALER			131072		//ǿ	üµ 
#define DM_ACT_SALER			262144		//߰	 
#define DM_ACT_NOKILL			1048576		//빫	 ƿ ȸ-_-;
#define DM_ACT_GUILD			16777216	//   
#define DM_ACT_NOR_SALER		134217728	//Ϲݻ	  Ǹ

/*
 * J : Current affects(  ׻ Ǵ ȿ)
 */
#define DM_AFF_POISON			4		//	׻ ɷ-_-;
#define DM_AFF_INVISIBLE		8		//	(÷   )
#define DM_AFF_DETECT_INVIS		16		//		    
#define DM_AFF_INFRAVISION		32		//		ο    
#define DM_AFF_WATERWALK		64		//		 յ-_-;
#define DM_AFF_PARALYZE			128		//		
#define DM_AFF_GANGHWA			256		//ȭ	ȭħ
#define DM_AFF_CURSE			512		//ȥ	    
#define DM_AFF_SANCTUARY		1024	//		庮
#define DM_AFF_HIDE				2048	//		
#define DM_AFF_SENSE_LIFE		4096	//	Ⱘ	 -_-;
#define DM_AFF_NO_SPEAK			8192	//		 
#define DM_AFF_DEX				16384	//		Ȯ 
#define DM_AFF_KILL				32768	//	
#define DM_AFF_HIDE_IN			65536	//ź	ź( :  ٱ)
#define DM_AFF_WIAP				131072	//		ȿ(..?)

/*
Ʈ
100	ں
101	յ
102	о̱
103	
104	

111	⿵
112	
113	ɸ
114	ȥ

120	ȯǳ
121	ǳ
122	ǳŸ
	
130	˺
131	̱
132	ݺ

200	
201	쵶
202	޵
203	Ÿ

210	б	
211	Ͻ	
212	ϱ
213	н
214	ż	

220	;
221	ϰʻ
222	Ȥ
223	
	
230	
231	
232	ź
	
300	ڹ
301	
302	
303	ġ

310	Ҹġ
311	ġ
312	ġ
313	

320	װɱ
321	
322	ġ
323	

330	
331	ĺ
332	
333	ϱ

340	
341	
	
400	
401	
402	庮
403	
404	Ǯ

410	ȯ
411	
412	żȯ
413	ų
414	ȭ

420	
422	ȣ
423	
424	
425	ȸ

426	ĥ
427	Ǹ
428	
429	ȯ
430	̷

431	ķ
432	
433	
	
500	
501	ġ
502	
503	

510	¤
511	޼
512	
513	

520	Ȱħ
521	ȯ
522	ġ
523	ص
524	
525	ȭ
526	ȯ
527	
528	
529	

530	
531	ȯ

600	ǳ
601	ǳź
602	
603	

610	
611	
612	
613	
614	

620	
621	
622	
623	

630	
631	
632	
633	

700	
701	ں
702	
703	
704	
705	ϰ
706	ȯ
707	ܿ
708	ɳ
709	˺
710	̱
711	
712	ư


  Ÿ	
11000	θ	θ( -ҷ⸸)
11001	Ű	Ű( -ֱ⸸)
11002		 
11003	һձ	Կ һձ
11004	ܱ	 ܴ´.
11005	ձ	Կ  .
11006	԰	Է  ~.
11007	ȯ	?
11008	ο򸻸	ⰰε..
11009		⸦ վ
11010		ϴÿ  ½
11011	 	
11012		ٸ ĵĵ
11013	ȯȯ	 ȯ
11014	ǳȸ	ȸٶ 
11015	ǳ	Կ  ~
11016	ȸɰ	ڷ  ..
11017	ٰ	⸦ پ~(???)

10004		 
10005		
10006		
10007	̱	 
10008		ٸ (б⺸ Ѽ)

20000	Ǽ	õ
20001		õ
20002	â	õ
20003		õ
20004	ߺ	õ
20005	ä	õ
20006		õ
20007		õ
20008	ä	õ
20009	Ȱ	õ
	
(lib\mulgeon\*.mul)

+ǹȣ
Ǻ%
̸%
ª %
 伳
%
A B C D
E F G H I
J K L M N
E 

A : Ÿ
*/

#define DI_TYPE_TRASH	0	//
#define DI_TYPE_WEAPON	1	//
#define DI_TYPE_ARMOR	2	//
#define DI_TYPE_FOOD	3	//԰Ÿ
#define DI_TYPE_CONTAINER	4	//
#define DI_TYPE_LIGHT	5	//
#define DI_TYPE_MONEY	6	//
#define DI_TYPE_NOTE	7	//
#define DI_TYPE_CORPSE	8	//ְ
#define DI_TYPE_SCROLL	9	// 
#define DI_TYPE_KEY	10//
#define DI_TYPE_DRINKCON	11//
#define DI_TYPE_TREASURE	12//
#define DI_TYPE_WAND	13//Ȱ
#define DI_TYPE_MISSILE	14//ȭ
#define DI_TYPE_TRANSFER	15//?

/*
B : 
C : ġ(0 = Auto : ڵ  )
D : (簡 ƽⰣ)
E : 
*/
#define DI_CLASS_2H		(1 << 0)	//
#define DI_CLASS_SWORD	(1 << 1)	//
#define DI_CLASS_SPEAR	(1 << 2)	//â
#define DI_CLASS_STAFF	(1 << 3)	//
#define DI_CLASS_HEAVY	(1 << 4)	//ߺ
#define DI_CLASS_FIST	(1 << 5)	//ָ()
#define DI_CLASS_KNIFE	(1 << 6)	//
#define DI_CLASS_MACE	(1 << 7)	//
#define DI_CLASS_PAN	(1 << 8)	//(ä)
#define DI_CLASS_ROD	(1 << 9)	//(ä)
#define DI_CLASS_BOW	(1 << 10)	//Ȱ

/*
ڽ ڿ 1  չⰡ 
EX) 3 = հ, 65 = յ

F : ı / ʰ
G : Ȯ / ȸǷ
H : Դº
*/
#define DI_WEAR_HEAD	(1 << 0)	//Ӹ
#define DI_WEAR_NECK	(1 << 1)	//
#define DI_WEAR_ARMS	(1 << 2)	//
#define DI_WEAR_BODY	(1 << 3)	//
#define DI_WEAR_WINGS	(1 << 4)	//ѿ
#define DI_WEAR_WRIST	(1 << 5)	//
#define DI_WEAR_HAND	(1 << 6)	//
#define DI_WEAR_WIELD	(1 << 7)	//( !)
#define DI_WEAR_HOLD	(1 << 8)	//ִ°
#define DI_WEAR_WAIST	(1 << 9)	//㸮
#define DI_WEAR_LEGS	(1 << 10)	//ٸ
#define DI_WEAR_KNEE	(1 << 11)	//
#define DI_WEAR_FEET	(1 << 12)	//
#define DI_WEAR_EAR		(1 << 13)	//

/*
I : ?
J : Ա Ǵ Ǽ(ߺ)
*/

#define DI_EX_ANTI_NOJOB	(1 << 0)	//X	
#define DI_EX_ANTI_PALADIN1 (1 << 1)	//X	
#define DI_EX_ANTI_THIEF	(1 << 2)	//X	
#define DI_EX_ANTI_CLERIC	(1 << 3)	//ǿX	
#define DI_EX_ANTI_NINJA	(1 << 4)	//ڰX	
#define DI_EX_ANTI_MAGIC1	(1 << 5)	//X	
#define DI_EX_ANTI_MAGIC2	(1 << 6)	//X	
#define DI_EX_INVISIBLE		(1 << 7)	//	 . ð ־   (-_-)
#define DI_EX_NOFIX			(1 << 8)	//Ұ	ȵ
#define DI_EX_UNBREAKABLE1	(1 << 9)	//Ҹ	 -_-;
#define DI_EX_AUTO_BREAK1	(1 << 10)	//ڵı	   ڵ ı
#define DI_EX_AUTO_BREAK2	(1 << 11)	//ı	    50%
#define DI_EX_NO_DROP		(1 << 12)	//Ұ	( : ȣ)
#define DI_EX_NO_SAVE		(1 << 13)	//Ұ	ȵ( : )
#define DI_EX_NO_TAKE		(1 << 14)	//Ұ	ȵ( : ȣ)
#define DI_EX_ANTI_MALE		(1 << 15)	//X	
#define DI_EX_ANTI_FEMALE	(1 << 16)	//X	
#define DI_EX_ANTI_NOGENDER (1 << 17)	//X	
#define DI_EX_ANTI_PALADIN2 (1 << 18)	//˻X	
#define DI_EX_NO_CONTAIN	(1 << 19)	//ֱҰ	濡  ( : ָӴ)
#define DI_EX_NO_PICKUP		(1 << 20)	//ġҰ	ġ Ұ( : ȣ)
#define DI_EX_NO_RENT		(1 << 21)	//ֱҰ	 ( : ȣ)
#define DI_EX_UNBREAKABLE2	(1 << 22)	//μҰ	 μ
#define DI_EX_NO_DEATH		(1 << 23)	//׾	׾ ǰ ( : ȣ)

/*
K : 
L, M, N : ?
׾Ʒ Ǽ
*/

#define DI_APPLY_NON		0	//
#define DI_APPLY_STR		1	//
#define DI_APPLY_DEX		2	//
#define DI_APPLY_INT		3	//
#define DI_APPLY_WIS		4	//
#define DI_APPLY_CON		5	//
#define DI_APPLY_CHA		6	//
#define DI_APPLY_LCK		7	//
#define DI_APPLY_INVIS		8	//
#define DI_APPLY_SEE_INVIS	9	//
#define DI_APPLY_HIT		10	//ְü
#define DI_APPLY_MANA		11	//
#define DI_APPLY_MOVE		12	//̵
#define DI_APPLY_AC			13	//
#define DI_APPLY_THAC0		14	//ȸǷ
#define DI_APPLY_DAMROLL	15	//ı
#define DI_APPLY_HITROLL	16	//Ȯ
#define DI_APPLY_REFRESH	17	//ȸ
#define DI_APPLY_NOENEMY	18	//
#define DI_APPLY_SAV_POISON	19	//
#define DI_APPLY_PROTECT	20	//ȭ
#define DI_APPLY_SAV_PARAL	21	//
#define DI_APPLY_SWIM		22	//
#define DI_APPLY_SAV_SPELL2 23	//
#define DI_APPLY_SAV_SPELL3 24	//
#define DI_APPLY_SAV_SPELL4 25	//ȥ
#define DI_APPLY_SAV_SPELL5 26	//ݹݻ
#define DI_APPLY_SAV_SPELL6 27	//
#define DI_APPLY_SAV_SPELL7 28	//
#define DI_APPLY_SAV_SPELL8 29	//
#define DI_APPLY_SAV_SPELL9 30	//
#define DI_APPLY_SAV_SPELL10 31	//
#define DI_APPLY_SAV_SPELL11 32	//

/*
EX)
1 10 ( +10)
17 -20 (ȸ -20)
1011,1000,0101,0010,0000,0000


ġ(lib\baechi\*.bae)

+ȣ
ƽ
ȣ
	N ȣ Ѽ (N , X  , I  ִ )
		D ۹ȣ Ѽ Ȯ (D W, H, G   )
ȣ
.
.
@()

 ⺻ ̴.

)
+82608200	N 8200 10 2		D 8200 50 100@


 мغ.
+82 		->    Ǵ ȣ̴. Ǿڸ 1ڸ̻ ǰ ڴ ڸ ̴.
      	   	    , ,  ڴ 8200 ۵Ǹ,  8300 Ѿ  .
60  		->  ƽ.. 70ʰ 1ƽ̹Ƿ 뷫    1ð 10и 
8200		-> ġ ȣ
N 8200 10 2	-> 8200   ü 10, ̹濡  2̴.
		     ڴ  ó  õȴ.
		      ̳ , չȣ   ٵ,
		       8200~8204 2 10 á,
		      8205濡   Ǿ ִٸ, 8205濡   Ѵ.
           8205濡  , 10̾ƴ϶ ̻ ڸ ָ  ȴ.
		             Ѽ  ִ  .
		         2 ̹濡   Ѽ̴.
          ó ÿ 翬 Ѹ ȴ.
		        , ̹ ݴ ʰ, ̵ ʾҴٸ,   ȴ.
            , ̹濡   ִٸ, ̹濡  ʴ´.
		      翬,   ̻ ־  ʴ´.
		        , ټ  濡   ġϴ°  ̴.
          ⼭,       ٶٸ Ѽ ָ ȴ. -_-;
		      ٸδ, N 8200 50 2  ü 25 ٸ ó 25
             50 Ǿ .(** ٴ   !!)
		      (̷ ϸ   濡   Ǿ . ޹ ..)
D 8200 50 100	-> 8200  . D ٸ ϸ H , W Ա, G ǰ
                   ⼭ ,   ʰϸ   ʴ´.
		   50 ü ϴ  Ѽ(50̸̸ )
		   100  Ȯ(10)
                     Ѵٸ
                   1 10(ȿ  , 10%Ȯ)̳ 2 10 ָ ȴ.
		   Ž  ܹȣ Ƹ 4 100̾ ϴ.( 1 100)
@		-> ġ 
*/
