/*************************************************************************/
/*  File : Hangul.c					Part by MirrMud  */
/*  Maker : Mirr							 */     
/*************************************************************************/  
#include "kstbl.h"
#include "conf.h"
#include "sysdep.h"

int is_hangul(const unsigned char *str)
{
	/* ѱ θ ˻ */
	if (*str < 0xb0 || *str > 0xc8)
		return 0;

	++str;

	if (*str < 0xa1 || *str > 0xfe)
		return 0;

	return 1;
}

int is_han(unsigned char *str)
{
	unsigned char * tmp = str;
	
	if (!*tmp)
		return 0;

	while (*tmp)
	{
		if (!*(tmp + 1))	//  ڰ  ѱ ƴϴ.
			return 0;
		else if (!is_hangul(tmp)) //  ѱ üũ.
			return 0;

		tmp += 2;		// 2Ʈ 
	}

	return 1;
}

/* ħ ִ  ˻ϴ κԴϴ. ó  */
int under_han(const char *str)
{
	unsigned char high, low;
	int hightmp, lowtmp;
	int len;
	int found = 0;
	
	len = strlen(str);
	
	if (len < 2)
		return 0;

	lowtmp = str[len - 1];
	len -= 2;
	hightmp = str[len];

	if (lowtmp > -1)
	{
		while (len)
		{
			len--;

			if (len < 0)
				break;

			lowtmp = hightmp;
			hightmp = str[len];

			if ((hightmp < -1) && (lowtmp < -1))
			{
				found = 1;
				break;
			}
		}
	}
	else
		found = 1;

	if (!found)
		return 0;

	high = hightmp;
	low = lowtmp;
	high = KStbl[(high - 0xb0) * 94 + low - 0xa1] & 0x1f;

	if (high < 2 || high > 28)
		return 0;
	
	return 1;
}

char check_josa(char * check_on, const char * identifier, const char ** josa) // returns 1 if ok
{
	const char * josalist[5][2] =
	{
		{ "", "" },
		{ "", "" },
		{ "", "" },
		{ "", "" },
		{ "", "" },
	};

	int i;

	for (i = 0; i < 5; ++i)
	{
		if (!strncmp(josalist[i][0], identifier, strlen(josalist[i][0])) ||
			!strncmp(josalist[i][1], identifier, strlen(josalist[i][1])))
		{
			*josa = josalist[i][under_han(check_on) ? 0 : 1];
		    return 1;
		}
	}

	return 0;
}
	
/* ù ʼ ã κԴϴ. */
char *first_han(unsigned char *str)
{
	int i, Length;
	char *Result = "ZZZ";
	unsigned char str_0, str_1;
	
	static unsigned char *exam[] =
	{
		"", "", "", "", "",
		"", "", "", "", "",
		"", "", "", "", "",
		"ī", "Ÿ", "", "", ""
	};

	static unsigned char *johab_exam[] =
	{
		"a", "a", "a", "a", "a",
		"a", "a", "a", "a", "a",
		"a", "a", "a", "a", "a",
		"a", "a", "a", "a", "" 
	};

	Length = strlen(str);

	if (Length < 2)
		return Result;
	
	str_0 = str[0]; str_1 = str[1];

	if (!is_hangul(&str[0]))
		return Result;
	
	str_0 = (KStbl[(str_0 - 0xb0) * 94 + str_1 - 0xa1] >> 8) & 0x7c;

	for (i = 0; johab_exam[i][0]; i++)
	{
		str_1 = (johab_exam[i][0] & 0x7f);  

		if (str_1 == str_0)
			return exam[i];
	}

	return Result;
}
