/* *********************************************************************** *
 *  File: mobconv.c                                                         *
 *  Usage: Convert DangunMud's .mob file into  series of circle's.mob files *
 *                                   									   *
 *   LONG_DESCRIPTION  SHORT_DESCR                        *
 *  (̵  Ʈ 濡 簡 short descr Ǿ )          *
 *   short descr name ü                                      *
 ************************************************************************** */
#include "conf.h"
#include "sysdep.h"
#include "structs.h"
#include "dangun.h"
#include "Utils.h"

//#define __DEBUG		1

#define STRING_TERMINATOR '~'

#define MOB_FLAGS(ch)	((ch)->char_specials.saved.act)
#define AFF_FLAGS(ch)	((ch)->char_specials.saved.affected_by)

/**************************************************************************
 *  declarations of most of the 'global' variables                         *
 ************************************************************************ */
struct char_data *wmob = NULL; /* arry of mobs */
char *buf, *buf1, *buf2;
int d_skill[32],d_practice[32],d_dummy[32];
int skill_cnt;

/**************************************************************************
 * declarations of local function 																				 *
 ************************************************************************ */
int thaco(int class_num, int level);
int load_mob(FILE *fl,mob_vnum virtual_nr,int mob_nr);
void write_mob(FILE *fd, mob_vnum mvnum, int mob_nr);
int do_convert(FILE * dan_f, FILE * newdan_f, char *filename);

int thaco(int class_num, int level)
{
	switch (class_num)
	{
		case CLASS_NOJOB:
			switch (level)
			{
				case  0: return 100;
				case  1: return  15;
				case  2: return  15;
				case  3: return  15;
				case  4: return  15;
				case  5: return  15;
				case  6: return  15;
				case  7: return  15;
				case  8: return  15;
				case  9: return  15;
				case 10: return  14;
				case 11: return  14;
				case 12: return  14;
				case 13: return  14;
				case 14: return  13;
				case 15: return  13;
				case 16: return  13;
				case 17: return  13;
				case 18: return  13;
				case 19: return  12;
				case 20: return  12;
				case 21: return  12;
				case 22: return  11;
				case 23: return  11;
				case 24: return  11;
				case 25: return  11;
				case 26: return  11;
				case 27: return  11;
				case 28: return  10;
				case 29: return  10;
				case 30: return  10;
				case 31: return   9;
				case 32: return   9;
				case 33: return   8;
				case 34: return   8;
				case 35: return   7;				
				default:
						 if (level > 35)
							 return 5;
			}
			break;

		case CLASS_SHAMAN:
			switch (level)
			{
				case  0: return 100;
				case  1: return  20;
				case  2: return  20;
				case  3: return  20;
				case  4: return  19;
				case  5: return  19;
				case  6: return  19;
				case  7: return  18;
				case  8: return  18;
				case  9: return  18;
				case 10: return  17;
				case 11: return  17;
				case 12: return  17;
				case 13: return  16;
				case 14: return  16;
				case 15: return  16;
				case 16: return  15;
				case 17: return  15;
				case 18: return  15;
				case 19: return  14;
				case 20: return  14;
				case 21: return  14;
				case 22: return  13;
				case 23: return  13;
				case 24: return  13;
				case 25: return  12;
				case 26: return  12;
				case 27: return  12;
				case 28: return  11;
				case 29: return  11;
				case 30: return  11;
				case 31: return  10;
				case 32: return  10;
				case 33: return  10;
				case 34: return   9;
				default:
						 if (level >= 35) return 0;
			}
			break;

		case CLASS_HEALER:
			switch (level)
			{
				case  0: return 100;
				case  1: return  20;
				case  2: return  20;
				case  3: return  20;
				case  4: return  18;
				case  5: return  18;
				case  6: return  18;
				case  7: return  16;
				case  8: return  16;
				case  9: return  16;
				case 10: return  14;
				case 11: return  14;
				case 12: return  14;
				case 13: return  12;
				case 14: return  12;
				case 15: return  12;
				case 16: return  10;
				case 17: return  10;
				case 18: return  10;
				case 19: return   8;
				case 20: return   8;
				case 21: return   8;
				case 22: return   6;
				case 23: return   6;
				case 24: return   6;
				case 25: return   4;
				case 26: return   4;
				case 27: return   4;
				case 28: return   2;
				case 29: return   2;
				case 30: return   2;
				case 31: return   1;
				case 32: return   1;
				case 33: return   1;
				case 34: return   1;
				default:
						 if (level >= 35) return 0;
			}
			break;

		case CLASS_THIEF:
			switch (level)
			{
				case  0: return 100;
				case  1: return  20;
				case  2: return  20;
				case  3: return  19;
				case  4: return  19;
				case  5: return  18;
				case  6: return  18;
				case  7: return  17;
				case  8: return  17;
				case  9: return  16;
				case 10: return  16;
				case 11: return  15;
				case 12: return  15;
				case 13: return  14;
				case 14: return  14;
				case 15: return  13;
				case 16: return  13;
				case 17: return  12;
				case 18: return  12;
				case 19: return  11;
				case 20: return  11;
				case 21: return  10;
				case 22: return  10;
				case 23: return   9;
				case 24: return   9;
				case 25: return   8;
				case 26: return   8;
				case 27: return   7;
				case 28: return   7;
				case 29: return   6;
				case 30: return   6;
				case 31: return   5;
				case 32: return   5;
				case 33: return   4;
				case 34: return   4;
				default:
						 if (level >= 35)
							 return 0;
			}
			break;

		case CLASS_ASSASIN:
			switch (level)
			{
				case  0: return 100;
				case  1: return  20;
				case  2: return  20;
				case  3: return  19;
				case  4: return  19;
				case  5: return  18;
				case  6: return  18;
				case  7: return  17;
				case  8: return  17;
				case  9: return  16;
				case 10: return  16;
				case 11: return  15;
				case 12: return  15;
				case 13: return  14;
				case 14: return  14;
				case 15: return  13;
				case 16: return  13;
				case 17: return  12;
				case 18: return  12;
				case 19: return  11;
				case 20: return  11;
				case 21: return  10;
				case 22: return  10;
				case 23: return   9;
				case 24: return   9;
				case 25: return   8;
				case 26: return   8;
				case 27: return   7;
				case 28: return   7;
				case 29: return   6;
				case 30: return   6;
				case 31: return   5;
				case 32: return   5;
				case 33: return   4;
				case 34: return   4;
				default:
						 if (level >= 35)
							 return 0;
			}
			break;

		case CLASS_MUSA:
			switch (level)
			{
				case  0: return 100;
				case  1: return  20;
				case  2: return  19;
				case  3: return  18;
				case  4: return  17;
				case  5: return  16;
				case  6: return  15;
				case  7: return  14;
				case  8: return  14;
				case  9: return  13;
				case 10: return  12;
				case 11: return  11;
				case 12: return  10;
				case 13: return   9;
				case 14: return   8;
				case 15: return   7;
				case 16: return   6;
				case 17: return   5;
				case 18: return   4;
				case 19: return   3;
				case 20: return   2;
				case 21: return   1;
				case 22: return   1;
				case 23: return   1;
				case 24: return   1;
				case 25: return   1;
				case 26: return   1;
				case 27: return   1;
				case 28: return   1;
				case 29: return   1;
				case 30: return   1;
				case 31: return   1;
				case 32: return   1;
				case 33: return   1;
				case 34: return   1;
				default:
						 if (level >= 35)
							 return 0;
			}
			break;

		case CLASS_FIST:
			switch (level)
			{
				case  0: return 100;
				case  1: return  20;
				case  2: return  19;
				case  3: return  18;
				case  4: return  17;
				case  5: return  16;
				case  6: return  15;
				case  7: return  14;
				case  8: return  14;
				case  9: return  13;
				case 10: return  12;
				case 11: return  11;
				case 12: return  10;
				case 13: return   9;
				case 14: return   8;
				case 15: return   7;
				case 16: return   6;
				case 17: return   5;
				case 18: return   4;
				case 19: return   3;
				case 20: return   2;
				case 21: return   1;
				case 22: return   1;
				case 23: return   1;
				case 24: return   1;
				case 25: return   1;
				case 26: return   1;
				case 27: return   1;
				case 28: return   1;
				case 29: return   1;
				case 30: return   1;
				case 31: return   1;
				case 32: return   1;
				case 33: return   1;
				case 34: return   1;
				default:
						 if (level >= 35) return	0;
			}
			break;

		default:
			printf("SYSERR: Unknown class in thac0 chart.");
			return	0;
	}

	/* Will not get there unless something is wrong. */
	return 100;
}

int load_mob(FILE *fl,mob_vnum virtual_nr,int mob_nr)
{
	struct char_data * mob;
	const char *err = NULL;
	int retval, lines;
	int d_type, d_class, d_ddi, d_level;
	float d_factor;
	int d_sex, d_age, d_pos, chclass;
	int i_skill = 0, i_practice = 0, i_dummy, i_thaco = 20;
	ull_int d_action, d_affect;
	char f_str[256], d_str[256];
	char flag_1[64], flag_2[64], flag_3[64];
	char abuf[64], bbuf[64];

#if defined(__DEBUG)
	printf("Start of load_mob(%d)---------------------------------\n",virtual_nr);
#endif
	mob = &wmob[mob_nr];

	mob->nr = virtual_nr;

	mob->player.name = fread_str(fl, err);
	mob->player.short_descr = fread_str(fl, err);
	mob->player.long_descr = fread_str(fl, err);
	mob->player.description = fread_str(fl,err);

	// charater's ability(action,affection...)
	lines = get_line(fl, flag_1);
#if defined(__DEBUG)
	printf("lines(%d):%s\n",lines,flag_1);
#endif  
	retval = sscanf(flag_1, "%d %d %d %d %1.1f\n",&d_type,&d_class,&d_ddi,&d_level,&d_factor);

	lines = get_line(fl,flag_2);
#if defined(__DEBUG)
	printf("lines(%d):%s\n",lines,flag_2);
#endif 
	retval = sscanf(flag_2, "%d %d %d %d %d\n",&d_sex,&d_age,&d_pos,&d_action,&d_affect);

	lines = get_line(fl,flag_3);
#if defined(__DEBUG)
	printf("lines(%d):%s\n",lines,flag_3);
#endif

	switch (d_sex)
	{
		case 1: 
		case 2:
			mob->player.sex = d_sex;
			break;
			
		default:
			mob->player.sex = 0;
			break;
	}
	
	chclass = d_class / 100;

	switch (chclass)
	{
		case 1:
			switch (d_class)
			{
				case 101:
					mob->mob_specials.mclass = MCLASS_LOWMUSA;  // ϱ޹
					break;
					
				case 102:
					mob->mob_specials.mclass = MCLASS_MIDMUSA; 	// ߱޹
					break;
					
				case 103:
					mob->mob_specials.mclass = MCLASS_UPPERMUSA;	// ޹
					break;

				case 104:
					mob->mob_specials.mclass = MCLASS_TOPMUSA;	//ֻ޹
					break;

				case 105:
					mob->mob_specials.mclass = MCLASS_DEFMUSA;	//
					break;

				case 106:
					mob->mob_specials.mclass = MCLASS_GROUPMUSA;	//
					break;

				case 107:
					mob->mob_specials.mclass = MCLASS_SOLDIER;	//ϱ޺
					break;

				case 108:
					mob->mob_specials.mclass = MCLASS_VETERAN;	//߱޺
					break;

				case 109:
					mob->mob_specials.mclass = MCLASS_GENERAL;	//
					break;

				case 110:
					mob->mob_specials.mclass = MCLASS_BERSERK;	//
					break;

				case 111:
					mob->mob_specials.mclass = MCLASS_BROKER;	//ذ
					break;

				case 112:
					mob->mob_specials.mclass = MCLASS_SCAMP;		//Ǵ
					break;

				case 113:
					mob->mob_specials.mclass = MCLASS_ZEALOT;	//ŵ
					break;


			}
			mob->player.chclass = CLASS_MUSA;
			break;
			
		case 2:
			mob->player.chclass = CLASS_ASSASIN;
			switch (d_class)
			{
				case 201:
					mob->mob_specials.mclass = MCLASS_LOWASSASIN;	//ϱڰ
					break;
				case 202:
					mob->mob_specials.mclass = MCLASS_MIDASSASIN;	//߱ڰ
					break;

				case 203:
					mob->mob_specials.mclass = MCLASS_UPPERASSASIN;	//ڰ
					break;
				case 204:
					mob->mob_specials.mclass = MCLASS_TOPASSASIN;	//ֻڰ
					break;

				case 205:
					mob->mob_specials.mclass = MCLASS_AMBUSHER;	//ź
					break;
				case 206:
					mob->mob_specials.mclass = MCLASS_ASSASINMASTER;	//
					break;
				case 207:
					mob->mob_specials.mclass = MCLASS_WANGJJA;	//¥
					break;
			}
			break;

		case 3:
			mob->player.chclass = CLASS_THIEF;
			switch (d_class)
			{
				case 300:
					mob->mob_specials.mclass = MCLASS_LION;	//񰢻
					break;
				case 301:
					mob->mob_specials.mclass = MCLASS_PICKPOCKET;	//Ҹġ
					break;
				case 302:
					mob->mob_specials.mclass = MCLASS_THIEF;		//
					break;
				case 303:
					mob->mob_specials.mclass = MCLASS_BANDIT;	//
				break;
				case 304:
					mob->mob_specials.mclass = MCLASS_GHOSTTHIEF;	//
					break;
				case 305:
					mob->mob_specials.mclass = MCLASS_SNATHER;	//ġ
					break;
				case 306:
					mob->mob_specials.mclass = MCLASS_ROBBER;	//
					break;
			}
			break;

		case 4:
			switch (d_class)
			{
				case 401:
					mob->mob_specials.mclass = MCLASS_CURSESHAMAN;	// ֻ
					break;
				case 402:
					mob->mob_specials.mclass = MCLASS_VIGORSHAMAN;	// Ȱ
					break;

				case 403:
					mob->mob_specials.mclass = MCLASS_SUMMONSHAMAN;	// ȯ
					break;

				case 404:
					mob->mob_specials.mclass = MCLASS_SPIRITSHAMAN;	// 
					break;

				case 405:
					mob->mob_specials.mclass = MCLASS_WARSHAMAN;		// ļ
					break;
			}
			mob->player.chclass = CLASS_SHAMAN;
			break;

		case 5:
			switch (d_class)
			{
				case 501:
					mob->mob_specials.mclass = MCLASS_WARHEALER;	// ǿ
					break;

				case 502:
					mob->mob_specials.mclass = MCLASS_ACUPUNCTURIST;	// ħ
					break;
				case 503:
					mob->mob_specials.mclass = MCLASS_BLINDIST;	// Ȼ
					break;
				case 504:
					mob->mob_specials.mclass = MCLASS_DUMBIST;	// 
					break;

				case 505:
					mob->mob_specials.mclass = MCLASS_POISONER;	// ǿ
					break;
			}
			mob->player.chclass = CLASS_HEALER;
			break;

		case 6:
			switch (d_class)
			{		
				case 601:
					mob->mob_specials.mclass = MCLASS_WINDDOIN;		// ٶ
					break;

				case 602:
					mob->mob_specials.mclass = MCLASS_CLOUDDOIN;		// 
					break;

				case 603:
					mob->mob_specials.mclass = MCLASS_RAINDOIN;		// 쵵
					break;

				case 605:
					mob->mob_specials.mclass = MCLASS_DRAGONDOIN;		// 뵵
					break;

				case 606:
					mob->mob_specials.mclass = MCLASS_THUNDERDOIN;		// 
					break;

				case 607:
					mob->mob_specials.mclass = MCLASS_DEFDOIN;		// 浵
					break;

				case 608:
					mob->mob_specials.mclass = MCLASS_WARDOIN;		// ӵ
					break;
			}
			mob->player.chclass = CLASS_DOIN;
			break;

		case 7:
			switch (d_class)
			{		
				case 701:
					mob->mob_specials.mclass = MCLASS_LOWSWORD;	// ϱް˻
					break;
					
				case 702:
					mob->mob_specials.mclass = MCLASS_MIDSWORD; 	// ߱ް˻
					break;
					
				case 703:
					mob->mob_specials.mclass = MCLASS_UPPERSWORD;	// ް˻
					break;

				case 704:
					mob->mob_specials.mclass = MCLASS_TOPSWORD;		//ʰ˻
					break;

				case 705:
					mob->mob_specials.mclass = MCLASS_SMASTER;		//˼
					break;
			}
			mob->player.chclass = CLASS_SWORD;
			break;

		case 8:
			switch (d_class)
			{
				case 801:
					mob->mob_specials.mclass = MCLASS_LOWFIST;	// ǹ
					break;
			}
			mob->player.chclass = CLASS_FIST;
			break;

		default:
			mob->player.chclass = CLASS_NOJOB;
			mob->mob_specials.mclass = 1;
	}

	mob->player.level = d_level; // in mobfile 
	//mob->player.hometown = 0; //Ž /ƻ ......߿

	switch (d_type)
	{
		case DM_C_UNDEF:
			mob->player.race = RACE_UNDEFINED; //
			break;

		case DM_C_HUMAN:
			mob->player.race = RACE_HUMAN; //ΰ
			break;

		case DM_C_ANIMAL:
			mob->player.race  = RACE_ANIMAL; //
			break;

		case DM_C_BEAST:
			mob->player.race  = RACE_BEAST; //ͼ
			break;

		case DM_C_POISON_BEAST:
			mob->player.race  = RACE_POISON_BEAST; //,  ...
			break;

		case DM_C_HORN:
			mob->player.race = RACE_HORN;	// 
			break;

		case DM_C_WING:
			mob->player.race  = RACE_WING; //
			break;

		case DM_C_WATER_BEAST:
			mob->player.race  = RACE_WATER_BEAST; //
			break;

		case DM_C_INSECT:
			mob->player.race  = RACE_INSECT; //
			break;
			
		case DM_C_POISON_INSECT:
			mob->player.race = RACE_POISON_INSECT;	// 
			break;

		case DM_C_GIANT:
			mob->player.race  = RACE_GIANT; //
			break;

		case DM_C_GHOST:
			mob->player.race  = RACE_GHOST; //ͽ
			break;

		case DM_C_GHOST2:
			mob->player.race  = RACE_GHOST2; //ͽ2
			break;

		case DM_C_HORN_GOBLIN:
			mob->player.race  = RACE_HORN_GOBLIN; //
			break;

		case DM_C_GOBLIN:
			mob->player.race  = RACE_GOBLIN; //ٺ 
			break;

		case DM_C_SPIRIT:
			mob->player.race  = RACE_SPIRIT; //
			break;

		case DM_C_ADV_SPIRIT:
			mob->player.race  = RACE_ADV_SPIRIT; //ż
			break;

		case DM_C_IMMORTAL:
			mob->player.race  = RACE_IMMORTAL; //
			break;
		
		case 1200:
			mob->player.race = RACE_IMMORTAL;	//
			break;

		default:
			printf("Undefined type(%d) ... confirm\n",d_type); //Ÿ ã ....
			getchar();
	}

	switch (d_ddi)
	{
		case 0:
			mob->player.zodiac = ZOD_JA;
			break;
		case 1:
			mob->player.zodiac = ZOD_CHUCK;
			break;
		case 2:
			mob->player.zodiac = ZOD_IN;
			break;
		case 3:
			mob->player.zodiac = ZOD_MYO;
			break;
		case 4:
			mob->player.zodiac = ZOD_JIN;
			break;
		case 5:
			mob->player.zodiac = ZOD_SA;
			break;
		case 6:
			mob->player.zodiac = ZOD_OH;
			break;
		case 7:
			mob->player.zodiac = ZOD_MI;
			break;
		case 8:
			mob->player.zodiac = ZOD_SIN;
			break;
		case 9:
			mob->player.zodiac = ZOD_YU;
			break;
		case 10:
			mob->player.zodiac = ZOD_SUL;
			break;
		case 11:
			mob->player.zodiac = ZOD_HAE;
			break;
		default:
			mob->player.zodiac = ZOD_JA;
	}

	/* Mobiles's Point */
	mob->points.max_hit  = 0;	// ̷ ϸ, dice(hit,mana)+move 
	mob->points.hit = 2 * d_level + 10;		// xdy+z: x
	mob->points.mana = 4 * d_level + 10;		// xdy+z: y
	mob->points.move = 5 * d_level + 10;		// xdy+z: z
	mob->points.armor = 10*10;	// 10: naked person, 0: heavily weared, -10:God 
	mob->points.gold = 50000;	// re-leveling ʿ
	mob->points.exp = 50001;	//   

	//i_thaco = thaco(mob->player.mclass, d_level);
	//mob->points.hitroll  = (int) (20 - i_thaco) * d_factor; // hitroll = 20 - THAC0 
	mob->points.hitroll  = (int) (20 - i_thaco); // hitroll = 20 - THAC0 
	mob->points.damroll  = 0;  // BHD xdy+z  z  strength bonus

	switch (d_pos)
	{
		case DM_SITTING:
			mob->char_specials.position  = POS_SITTING;
			mob->mob_specials.default_pos = POS_SITTING;
			break;
		case DM_FIGHTING:
			mob->char_specials.position  = POS_FIGHTING;
			mob->mob_specials.default_pos = POS_STANDING;
			break;
		case DM_SWIMMING:
			mob->char_specials.position  = POS_SWIMMING; //Ȯ ʿ
			mob->mob_specials.default_pos = POS_STANDING;
			break;
		case DM_RESTING:
			mob->char_specials.position  = POS_RESTING; 
			mob->mob_specials.default_pos = POS_RESTING;
			break;
		default:
			mob->char_specials.position  = POS_STANDING;
			mob->mob_specials.default_pos = POS_STANDING;
	}

	mob->char_specials.saved.alignment  = 0;  
	mob->mob_specials.damnodice = d_level/10; // BHD xdy+z  x
	mob->mob_specials.damsizedice = 4; // BHD xdy+  y

	/* Proccessing mob action flag */
	SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);
	if (IS_SET(d_action, DM_ACT_NONE)) SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);	
	if (IS_SET(d_action, DM_ACT_AGGRESSIVE)) SET_BIT_AR(MOB_FLAGS(mob),MOB_AGGRESSIVE);
	if (IS_SET(d_action, DM_ACT_MOVE_OUT)) SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);
	if (IS_SET(d_action, DM_ACT_STAY_ZONE)) SET_BIT_AR(MOB_FLAGS(mob),MOB_STAY_ZONE);
	if (IS_SET(d_action, DM_ACT_SCAVENGER)) SET_BIT_AR(MOB_FLAGS(mob),MOB_SCAVENGER);
	if (IS_SET(d_action, DM_ACT_WIMPY 	)) SET_BIT_AR(MOB_FLAGS(mob),MOB_WIMPY);
	if (IS_SET(d_action, DM_ACT_AGGR_WIMPY))
	{
		SET_BIT_AR(MOB_FLAGS(mob),MOB_AGGRESSIVE);
		SET_BIT_AR(MOB_FLAGS(mob),MOB_WIMPY);
	}
	if (IS_SET(d_action, DM_ACT_AGGR_BACKSTAB))
	{
		SET_BIT_AR(MOB_FLAGS(mob),MOB_AGGRESSIVE);
		SET_BIT_AR(MOB_FLAGS(mob),MOB_AWARE);
	}
	if (IS_SET(d_action, DM_ACT_DIGNITY))
	{ 
		SET_BIT_AR(MOB_FLAGS(mob),MOB_NOCHARM);
		SET_BIT_AR(MOB_FLAGS(mob),MOB_NOSUMMON);
		SET_BIT_AR(MOB_FLAGS(mob),MOB_NOBASH);
		SET_BIT_AR(MOB_FLAGS(mob),MOB_NOBLIND);
		SET_BIT_AR(MOB_FLAGS(mob),MOB_NOKILL);
		SET_BIT_AR(MOB_FLAGS(mob),MOB_NOTDEADYET);
	}

	   if (IS_SET(d_action, DM_ACT_HELPER)) SET_BIT_AR(MOB_FLAGS(mob),MOB_HELPER);
	   if (IS_SET(d_action, DM_ACT_BOSS)) SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC); 
	   if (IS_SET(d_action, DM_ACT_CITIZEN)) SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);
	   if (IS_SET(d_action, DM_ACT_EXP_ZERO)) SET_BIT_AR(MOB_FLAGS(mob),MOB_EXPZERO);
	   if (IS_SET(d_action, DM_ACT_TO_SKY)) SET_BIT_AR(MOB_FLAGS(mob),MOB_TO_SKY);
	   if (IS_SET(d_action, DM_ACT_USABLE)) SET_BIT_AR(MOB_FLAGS(mob),MOB_CHARM);
	   if (IS_SET(d_action, DM_ACT_WEARABLE)) SET_BIT_AR(MOB_FLAGS(mob),MOB_SPEC);
	   if (IS_SET(d_action, DM_ACT_NOKILL)) SET_BIT_AR(MOB_FLAGS(mob),MOB_NOKILL);
	   if (IS_SET(d_action, DM_ACT_NOR_SALER)) SET_BIT_AR(MOB_FLAGS(mob),MOB_SPEC);

/*	if (IS_SET(d_action, DM_ACT_HELPER))
	{
		SET_BIT_AR(MOB_FLAGS(mob),MOB_HELPER);
		mob->char_specials.position  = POS_SITTING;
		mob->mob_specials.default_pos = POS_SITTING;
	}// ...... ̵... */
	
	if (IS_SET(d_action, DM_ACT_HEALER))
	{
		SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);
		mob->char_specials.position  = POS_SITTING;
		mob->mob_specials.default_pos = POS_SITTING;
	}//  Ÿ  ɾְ ó... ȱ׷ ̵ع...
	if (IS_SET(d_action, DM_ACT_SALER))
	{
		SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);
		mob->char_specials.position  = POS_SITTING;
		mob->mob_specials.default_pos = POS_SITTING;
	}//  Ÿ  ɾְ ó... ȱ׷ ̵ع...
	if (IS_SET(d_action, DM_ACT_NOKILL)) SET_BIT_AR(MOB_FLAGS(mob),MOB_NOKILL);
	if (IS_SET(d_action, DM_ACT_NOR_SALER))
	{
		SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);
		mob->char_specials.position  = POS_SITTING;
		mob->mob_specials.default_pos = POS_SITTING;
	}//  Ÿ  ɾְ ó... ȱ׷ ̵ع...
	if (IS_SET(d_action, DM_ACT_GUILD))
	{
		SET_BIT_AR(MOB_FLAGS(mob),MOB_ISNPC);
		mob->char_specials.position  = POS_SITTING;
		mob->mob_specials.default_pos = POS_SITTING;
	}//  Ÿ  ɾְ ó... ȱ׷ ̵ع...

	/* proccessing Current affects(  ׻ Ǵ ȿ) */

	if (IS_SET(d_affect, DM_AFF_POISON	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_POISON);	
	if (IS_SET(d_affect, DM_AFF_INVISIBLE	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_INVISIBLE);
	if (IS_SET(d_affect, DM_AFF_DETECT_INVIS)) SET_BIT_AR(AFF_FLAGS(mob),AFF_DETECT_INVIS);
	if (IS_SET(d_affect, DM_AFF_INFRAVISION	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_INFRAVISION);
	if (IS_SET(d_affect, DM_AFF_WATERWALK	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_WATERWALK);
	if (IS_SET(d_affect, DM_AFF_PARALYZE	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_PARALYZE);
	if (IS_SET(d_affect, DM_AFF_GANGHWA	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_MAGICONLY);
	if (IS_SET(d_affect, DM_AFF_CURSE	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_CURSE);
	if (IS_SET(d_affect, DM_AFF_SANCTUARY	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_SANCTUARY);	
	if (IS_SET(d_affect, DM_AFF_HIDE	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_HIDE);	
	if (IS_SET(d_affect, DM_AFF_SENSE_LIFE	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_SENSE_LIFE);	
	if (IS_SET(d_affect, DM_AFF_NO_SPEAK	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_NOSPEAK);	
	if (IS_SET(d_affect, DM_AFF_DEX	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_HITROLL);	//	Ȯ ,߰
	if (IS_SET(d_affect, DM_AFF_KILL	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_KILL);	//,߰	
	if (IS_SET(d_affect, DM_AFF_HIDE_IN	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_HIDE);	//ź	
	if (IS_SET(d_affect, DM_AFF_WIAP	)) SET_BIT_AR(AFF_FLAGS(mob),AFF_MAGICONLY); //, ߰	

	sprintascii(abuf, MOB_FLAGS(mob)[0]);
	sprintascii(bbuf, AFF_FLAGS(mob)[0]);
	sprintf(f_str, "ActFlag:(%s) AffectFlag:(%s)\n", abuf, bbuf);
#if defined(__DEBUG)
	puts(f_str);
#endif
	skill_cnt = 0;

	for (;;)
	{
		lines = get_line(fl,d_str);
		d_str[strlen(d_str)]='\0';
#if defined(__DEBUG)
		printf("lines(%d):%s\n",lines,d_str);
#endif
		retval = sscanf(d_str,"%d %d %d\n",&i_skill,&i_practice,&i_dummy); 
		d_skill[skill_cnt]=i_skill;
		d_practice[skill_cnt]=i_practice;
		d_dummy[skill_cnt]=i_dummy;
		skill_cnt++;

		if (*d_str == 'C')
			continue;

		if (*d_str == 'E')
		{
#if defined(__DEBUG)
			printf("End of load_mob(%d)---------------------------------\n",virtual_nr);
#endif
			//free(mob);
			return 0;
		}
	}
}

void write_mob(FILE * fp, mob_vnum mvnum, int mob_nr)
{
	struct char_data * mob;
	//int i = 0;

	char fbuf1[MAX_STRING_LENGTH], fbuf2[MAX_STRING_LENGTH];
	char fbuf3[MAX_STRING_LENGTH], fbuf4[MAX_STRING_LENGTH];
	char abuf1[MAX_STRING_LENGTH], abuf2[MAX_STRING_LENGTH];
	char abuf3[MAX_STRING_LENGTH], abuf4[MAX_STRING_LENGTH];

	mob = &wmob[mob_nr];
	/*
	if (mob->player.long_descr)
	   strncpy(ldesc, mob->player.long_descr,strlen(mob->player.long_descr));
	*/
	fprintf(fp,
			"#%d\n"
			"%s%c\n"
			"%s%c\n"
			"%s%c\n"
			"%s%c\n",
			mvnum,
			mob->player.name, STRING_TERMINATOR,
			mob->player.short_descr, STRING_TERMINATOR,
			mob->player.long_descr, STRING_TERMINATOR,
			mob->player.description, STRING_TERMINATOR);

	sprintascii(fbuf1, MOB_FLAGS(mob)[0]);
	sprintascii(fbuf2, MOB_FLAGS(mob)[1]);
	sprintascii(fbuf3, MOB_FLAGS(mob)[2]);
	sprintascii(fbuf4, MOB_FLAGS(mob)[3]);
	
	sprintascii(abuf1, AFF_FLAGS(mob)[0]);
	sprintascii(abuf2, AFF_FLAGS(mob)[1]);
	sprintascii(abuf3, AFF_FLAGS(mob)[2]);
	sprintascii(abuf4, AFF_FLAGS(mob)[3]);
	
	fprintf(fp, "%s %s %s %s %s %s %s %s %d E\n"
				"%d %d %d %dd%d+%d %dd%d+%d\n",
				fbuf1, fbuf2, fbuf3, fbuf4,
				abuf1, abuf2, abuf3, abuf4,
				mob->char_specials.saved.alignment,
				mob->player.level, 20 - mob->points.hitroll, mob->points.armor / 10,
				mob->points.hit, mob->points.mana, mob->points.move,
				mob->mob_specials.damnodice, mob->mob_specials.damsizedice, mob->points.damroll);
	
	fprintf(fp,		"%lld %lld %d %d %d %d\n"
			"%d %d %d\n",
			mob->points.gold, mob->points.exp, mob->player.race, mob->player.zodiac, mob->player.chclass,
			mob->mob_specials.mclass, mob->char_specials.position, mob->mob_specials.default_pos, mob->player.sex);

	//Ŀ  Ʈ ϰ ߰ϵ 
	//for (i = 0; i < skill_cnt - 1; ++i)
	//{
	//	if (d_dummy[i] != 0) fprintf(fp,"%d: %d %d\n",d_skill[i],d_practice[i],d_dummy[i]);
	//	else fprintf(fp,"%d: %d\n",d_skill[i],d_practice[i]);
	//}
	fprintf(fp, "E\n");
}


static int do_convert(FILE * dan_f, FILE * newdan_f, char * filename)
{
	char mhead[READ_SIZE];
	int virtual_nr, mob_nr,lines;

	CREATE(wmob, struct char_data, 512);
	mob_nr = 0;

#if defined(__DEBUG)
	printf(" Start of mob=========================================(mob:%d)\n",mob_nr);
#endif
	for (;;)
	{
		lines=get_line(dan_f,mhead);	
		mhead[strlen(mhead)]='\0';
#if defined(__DEBUG)
		printf("lines(%d):%s\n",lines,mhead);
#endif
		if (mhead[0] == '+')
		{
			/* start mob file */
			sscanf(mhead, "+%d\n", &virtual_nr);

			load_mob(dan_f, virtual_nr, mob_nr);
			write_mob(newdan_f, virtual_nr, mob_nr);

			if (wmob[mob_nr].player.name)
				free(wmob[mob_nr].player.name);

			if (wmob[mob_nr].player.short_descr)
				free(wmob[mob_nr].player.short_descr);

			if (wmob[mob_nr].player.long_descr)
				free(wmob[mob_nr].player.long_descr);

			if (wmob[mob_nr].player.description)
				free(wmob[mob_nr].player.description);

			mob_nr++;
		}
		else
		{
			if (mhead[0] == '@')
			{
				/* EOF */
				fprintf(newdan_f, "$~\n");
				break;
			}
			else
			{
				printf("%s: wrong format detected, conversion aborted!\n", filename);
				free(wmob);
				fclose(newdan_f);
				return (1);
			}
		}
	}

	free(wmob);
	fclose(newdan_f);
#if defined(__DEBUG)
	printf(" End of mob_nr===========================================(mob:%d)\n",mob_nr);
#endif
	return (0);
}

int mobconv(int argc, char ** argv)
{
	FILE *idxfp,*dfp, *ndfp;
	char fn[256], nfn[256];
	char idx_f[256],e_msg[256];
	int result, lines,mob_nr,retval,idx_flag;

	if (argc < 2)
	{
		printf("Usage: mobconv [Index] [<infile.mob> <outfile.mob>]\n");
		exit(1);
	}

	if (!strcmp(argv[1],"Index"))
	{
		printf("Converting each file \n");
		strcpy(fn,argv[1]);
		idx_flag=1;
	}
	else
		strcpy(fn,"Index");

	if (idx_flag==1)
	{
		idxfp = fopen("Index","r");

		if (idxfp == NULL)
		{
			strcat(e_msg, " Index: could not be opened");
			perror(e_msg);
			return(1);
		}
		else
		{
			for (;;)
			{
				lines=get_line(idxfp,idx_f);
				idx_f[strlen(idx_f)]='\0';
#if defined(__DEBUG)
				printf("lines(%d):%s\n",lines,idx_f);
#endif
				if (idx_f[0]=='$')
				{
					break;
				}

				retval=sscanf(idx_f,"%s %d\n",fn,&mob_nr);

				sprintf(nfn,"%d.mob",mob_nr);

#if defined(__DEBUG)
				printf("fn/mob_nr:%s/%d\n",fn,mob_nr);
#endif
				dfp = fopen(fn, "r");
				if (dfp == NULL)
				{
					sprintf(e_msg,"%s: could not be opened\n",fn);
					perror(e_msg);
				}
				else
				{
					if ((ndfp = fopen(nfn, "w")) == NULL)
					{
						printf("Error writing to %s.\n", fn);
						continue;
					}
					printf("%s:\n", nfn);

#if defined(__DEBUG)
					printf("**************Converting....:%s->%s\n",fn,nfn);
#endif
					result = do_convert(dfp, ndfp, fn);
#if defined(__DEBUG)
					printf("**************Converted:%s->%s\n",fn,nfn);
#endif
					fclose(ndfp);
					fclose(dfp);
				}
#if defined(__DEBUG)
				//	sleep(1); //for readability...
#endif
			}
		}
		fclose(idxfp);
	}
	else
	{
		sprintf(fn, "%s", argv[1]);
		sprintf(nfn, "%s", argv[2]);

#if defined(__DEBUG)
		printf("In File/Out File:%s/%s\n",fn,nfn);
#endif
		dfp = fopen(fn, "r");
		if (dfp == NULL)
		{
			sprintf(e_msg, "%s: could not be opened\n",fn);
			perror(e_msg);
		}
		else
		{
			if ((ndfp = fopen(nfn, "w")) == NULL)
			{
				printf("Error writing to %s.\n", fn);
			}
			printf("%s:\n", nfn);

#if defined(__DEBUG)
			printf("**************Converting....:%s->%s\n",fn,nfn);
#endif
			result = do_convert(dfp, ndfp, fn);
#if defined(__DEBUG)
			printf("**************Converted:%s->%s\n",fn,nfn);
#endif
			fclose(ndfp);
			fclose(dfp);
		}
	}
	if (result == 0) printf("Done!\n");
	else printf("Converting Failed!\n");
	return (0);
}
